        BAMS TECHNOLOGY LICENSE

The following license terms and conditions apply to this BAMS
software ("Software"), unless a different license is obtained from
Sendmail, Inc. at 6425 Christie Ave, Fourth Floor, Emeryville, CA 94608

=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

Copyright (c) 1999 - 2001
Sendmail, Inc.  All rights reserved.

License Terms:

Use, Modification and Redistribution (including distribution of
any modified or derived work) of the Software in source and binary
forms is permitted only if each of the following conditions is met:

1.  Redistributions of the Software and any modifications thereto
    or accompanying software that uses the Software are made at no
    charge beyond the reasonable cost of materials and delivery.

2.  Redistributions are accompanied by a complete copy of the Source
    Code or by an irrevocable offer to provide a complete copy of
    the Source Code for up to three years at the cost of materials
    and delivery.  Such redistributions must allow further use,
    modification, and redistribution of the Source Code under
    substantially the same terms as this license.  For the purposes
    of redistribution "Source Code" means the complete compilable
    and linkable source code of Software including all modifications
    and all accompanying software that uses the Software.  It does
    not include accompanying software modules or files that either
    (a) typically accompany the major components of the operating
    system on which the executable file runs, or (b) are distributed
    under another open source license, as defined by the Open Source
    Initiative (http://www.opensource.org).

3.  Redistributions of source code must retain the copyright notices
    as they appear in each source code file, these license terms,
    and the disclaimer/limitation of liability set forth as paragraph
    6 below.

4.  Redistributions in binary form must reproduce the Copyright
    Notice, these license terms, and the disclaimer/limitation of
    liability set forth as paragraph 6 below, in the documentation
    and/or other materials provided with the distribution.  For
    the purposes of binary distribution the "Copyright Notice"
    refers to the following language: "Copyright (c) 1999-2001
    Sendmail, Inc.  All rights reserved."

5.  Neither the name of Sendmail, Inc. nor its contributors may be
    used to endorse or promote products derived from this Software
    without specific prior written permission.  The name "sendmail"
    is a registered trademark of Sendmail, Inc.

6.  Disclaimer/Limitation of Liability: THIS SOFTWARE IS PROVIDED
    BY SENDMAIL, INC. AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR
    IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
    WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL SENDMAIL, INC. OR
    CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
    SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
    NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
    LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
    CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
    STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
    ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
    ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.


#include "db.h"				/* Berkley database definitions */

#define ODBC_TIMEOUT -99
#define CLUSTRA_TIMEOUT 224
#define CLUSTRA_UPGRADE_LOCK 2097
#define CLUSTRA_KEY_EXISTS 160

#define ODBC_MAXERRLEN 500
typedef struct{
    SQLCHAR error[ODBC_MAXERRLEN+1];    /* ODBC error string */
    SQLCHAR sqlstate[6];                /* ODBC 5-char error string */
    SDWORD nativeerror;                 /* ODBC native error code */
    SWORD errorlen;                     /* ODBC error string length */
} odbc_error_s;

/* : Function Prototypes */
#define msdb__record_put(a,b,c,d,e,f) (msdb__record_put_flags ((a),(b),(c),(d),(e),(f),0))
#define msdb__record_put_nooverwrite(a,b,c,d,e,f) (msdb__record_put_flags ((a),(b),(c),(d),(e),(f),DB_NOOVERWRITE))

int   	             	      	       /* R: -1 if error, else native error code */
get_native_error(    	      	       /* D: get error codes and mesg from ODBC */
      SQLHSTMT hstmt,	      	       /* I: stmt handle to get error from */
      odbc_error_s *error     	       /* O: error struct to put error into */ 
      );

void
print_error(         	      	       /* D: print content of an error struct */
      odbc_error_s error      	       /* I: error struct to print */
      );

int					/* R: 0 if ok, else errno */
msdb__record_put_flags (		/* D: put record in database */
  DB *db,				/* I: database table but is really
				         *  : table name, (char *). */
  DB_TXN *tid,				/* I: transaction id but is really
					 *  : (ODBC_ENV_t *). */
  void *key,				/* I: key */
  unsigned int key_len,			/* I: length of key data */
  void *val,				/* I: value */
  unsigned int val_len,			/* I: length of value data */
  u_int32_t flags                       /* I: db put() flags */
);

int					/* R: 0 if ok, else errno */
msdb__record_get (			/* D: get record from database */
  DB *db,				/* I: database table but is really
					    : table name, (char *). */
  DB_TXN *id,				/* I: transaction id */
  void *key,				/* I: key */
  unsigned int key_len,			/* I: length of key data */
  void **val,				/* O: value */
  unsigned int *val_len			/* O: length of value data */
);

int					/* R: 0 if ok, else errno */
msdb__record_del (			/* D: delete record from database */
  DB *db,				/* I: database table but is really
					    : table name, (char *). */
  DB_TXN *id,				/* I: transaction id but is really
					    : (ODBC_ENV_t *). */
  void *key,				/* I: key */
  unsigned int key_len			/* I: length of key data */
);

int					/* R: 0 if ok, else errno */
msdb__record_del_parts (		/* D: delete record from database where part>part_min*/
/* PARAMETERS */
  DB *db,				/* I: database table */
  DB_TXN *tid,				/* I: transaction id */
  void *key,				/* I: key */
  unsigned int key_len,			/* I: length of key data */
  unsigned int part_min               	/* I: delete all parts that is bigger than part_min */
/* END PARAMETERS */
);

int					/* R: 0 if ok, else errno */
msdb__record_exists (			/* D: check existance of record in database */
  DB * db,				/* I: message store database context */
  DB_TXN *id,				/* I: transaction id but is really
					    : (ODBC_ENV_t *). */
  void * key,				/* I: key to check for */
  unsigned int keylen,			/* I: length of key */
  void * val,				/* I: value to check for (if non-null) */
  unsigned int vallen			/* I: length of value (or 0) */
);

int					/* R: 0 if ok, else errno */
msdb__record_lock (			/* D: lock record in database */
  void
);

int					/* R: 0 if ok, else errno */
msdb__record_unlock (			/* D: unlock record in databse */
  void
);

int					/* R: 0 if ok, else errno */
msdb__cursor_open (			/* D: create new cursor */
  DB *db,				/* I: database table but is really
					    : table name, (char *). */
  DB_TXN *id,				/* I: transaction id but is really
					    : (ODBC_ENV_t *). */
  DBC **cursor				/* O: cursor pointer but is really
					    : (ODBC_ENV_t **) */
);

int					/* R: 0 if ok, else errno */
msdb__cursor_close (			/* D: close cursor */
  DBC **cursor				/* U: cursor pointer */
);

int					/* R: 0 if ok, else errno */
msdb__cursor_get_exact (		/* D: set cursor to given key */
  DBC *cursor,				/* I: cursor pointer but is really
					    : (ODBC_ENV_t *). */
  void *key,				/* I: key */
  unsigned int key_len,			/* I: length of key data */
  void **val,				/* O: value */
#ifdef	XXX_SLF_API_CHANGE_HACK
  unsigned int *val_len,		/* O: length of val data */
  int update                            /* I: update cursor? */
#else	/* XXX_SLF_API_CHANGE_HACK */
  unsigned int *val_len			/* O: length of val data */
#endif	/* XXX_SLF_API_CHANGE_HACK */
);

int					/* R: 0 if ok, else errno */
msdb__cursor_get_closest (		/* D: set cursor to key that closest matches pattern */
  DBC *cursor,				/* I: cursor pointer but is really
					    : (ODBC_ENV_t *). */
  void *pattern,			/* I: partial key */
  unsigned int pattern_len,		/* I: length of pattern */
  void **key,				/* O: key */
  unsigned int *key_len,		/* O: length of key data */
  void **val,				/* O: value */
#ifdef	XXX_SLF_API_CHANGE_HACK
  unsigned int *val_len,		/* O: length of val data */
  int update                            /* I: update cursor? */
#else	/* XXX_SLF_API_CHANGE_HACK */
  unsigned int *val_len			/* O: length of val data */
#endif	/* XXX_SLF_API_CHANGE_HACK */
);

int					/* R: 0 if ok, else errno */
msdb__cursor_get_first (		/* D: set cursor to first record */
  DBC *cursor,				/* I: cursor pointer but is really
					    : (ODBC_ENV_t *). */
  void **key,				/* O: key */
  unsigned int *key_len,		/* O: length of key data */
  void **val,				/* O: value */
#ifdef	XXX_SLF_API_CHANGE_HACK
  unsigned int *val_len,		/* O: length of val data */
  int update                            /* I: update cursor? */
#else	/* XXX_SLF_API_CHANGE_HACK */
  unsigned int *val_len			/* O: length of val data */
#endif	/* XXX_SLF_API_CHANGE_HACK */
);

int					/* R: 0 if ok, else errno */
msdb__cursor_get_next (			/* D: get next record */
  DBC *cursor,				/* I: cursor pointer but is really
					    : (ODBC_ENV_t *). */
  void **key,				/* O: key */
  unsigned int *key_len,		/* O: length of key data */
  void **val,				/* O: value */
  unsigned int *val_len			/* O: length of val data */
);

int					/* R: 0 if ok, else errno */
msdb__cursor_put_current (		/* D: overwrite current record */
  DBC *cursor,				/* I: cursor pointer but is really
					    : (ODBC_ENV_t *). */
  void *key,				/* I: key */
  unsigned int key_len,			/* I: length of key data */
  void *val,				/* I: value */
  unsigned int val_len			/* I: length of key val */
);

int					/* R: 0 if ok, else errno */
msdb__cursor_put_record (		/* D: add a record */
  DBC *cursor,				/* I: cursor pointer but is really
					    : (ODBC_ENV_t *). */
  void *key,				/* I: key */
  unsigned int key_len,			/* I: length of key data */
  void *val,				/* I: value */
  unsigned int val_len			/* I: length of key val */
);

int					/* R: 0 if ok, else errno */
msdb__cursor_del_current (		/* D: delete current record */
  DBC *cursor				/* I: cursor pointer but is really
					    : (ODBC_ENV_t *). */
);

int					/* R: 0 if ok, else errno */
msdb__transaction_begin (		/* D: begin a trasaction */
  DB_ENV *env,                          /* I: transaction manager */
  DB_TXN *pid,                          /* I: parent transaction id */
  DB_TXN **tid                          /* O: transaction id */
);

int					/* R: 0 if ok, else errno */
msdb__transaction_end (			/* D: end a transaction */
  DB_TXN *tid                           /* I: transaction id but is really
					    : (ODBC_ENV_t *). */
);

int					/* R: 0 if ok, else errno */
msdb__transaction_abort (		/* D: abort a transaction */
  DB_TXN *tid                           /* I: transaction id but is really
					    : (ODBC_ENV_t *). */
);

int					/* R: 0 if ok, else errno */
msdb__entries_count (			/* D: count the entries in a database */
  DB *db,				/* I: database table but is really
					    : table name, (char *). */
  long *count    			/* O: number of entries */
);

