        BAMS TECHNOLOGY LICENSE

The following license terms and conditions apply to this BAMS
software ("Software"), unless a different license is obtained from
Sendmail, Inc. at 6425 Christie Ave, Fourth Floor, Emeryville, CA 94608

=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

Copyright (c) 1999 - 2001
Sendmail, Inc.  All rights reserved.

License Terms:

Use, Modification and Redistribution (including distribution of
any modified or derived work) of the Software in source and binary
forms is permitted only if each of the following conditions is met:

1.  Redistributions of the Software and any modifications thereto
    or accompanying software that uses the Software are made at no
    charge beyond the reasonable cost of materials and delivery.

2.  Redistributions are accompanied by a complete copy of the Source
    Code or by an irrevocable offer to provide a complete copy of
    the Source Code for up to three years at the cost of materials
    and delivery.  Such redistributions must allow further use,
    modification, and redistribution of the Source Code under
    substantially the same terms as this license.  For the purposes
    of redistribution "Source Code" means the complete compilable
    and linkable source code of Software including all modifications
    and all accompanying software that uses the Software.  It does
    not include accompanying software modules or files that either
    (a) typically accompany the major components of the operating
    system on which the executable file runs, or (b) are distributed
    under another open source license, as defined by the Open Source
    Initiative (http://www.opensource.org).

3.  Redistributions of source code must retain the copyright notices
    as they appear in each source code file, these license terms,
    and the disclaimer/limitation of liability set forth as paragraph
    6 below.

4.  Redistributions in binary form must reproduce the Copyright
    Notice, these license terms, and the disclaimer/limitation of
    liability set forth as paragraph 6 below, in the documentation
    and/or other materials provided with the distribution.  For
    the purposes of binary distribution the "Copyright Notice"
    refers to the following language: "Copyright (c) 1999-2001
    Sendmail, Inc.  All rights reserved."

5.  Neither the name of Sendmail, Inc. nor its contributors may be
    used to endorse or promote products derived from this Software
    without specific prior written permission.  The name "sendmail"
    is a registered trademark of Sendmail, Inc.

6.  Disclaimer/Limitation of Liability: THIS SOFTWARE IS PROVIDED
    BY SENDMAIL, INC. AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR
    IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
    WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL SENDMAIL, INC. OR
    CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
    SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
    NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
    LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
    CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
    STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
    ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
    ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.


#include <stdio.h>
#include <pthread.h>

#include "msdb.h"
#include "mytest.h"
#define PROGRESS_MIN 1
#define	MAX_THREADS	50
#define MAX_TRANSACTIONS 5
#define TEST_TABLE "rw_test"

MS_DB_CONTEXT_t	*db = NULL;

struct testarg{
  int id,transactions,rollbacks;
};

char table_name[500];
char *dbname;

void *do_test_wrapper(void *p);
void *do_overwrite_wrapper(void *p);
void *do_read_exact_wrapper(void *p);
void *do_cursor_read_wrapper(void *p);
void *do_no_overwrite_wrapper(void *p);
void *do_exists_wrapper(void *p);
void *do_overwrite_var_wrapper(void *p);
void *do_read_exact_var_wrapper(void *p);
void *do_delete_var_wrapper(void *p);

void *do_overwrite_wrapper_exec(void *p);
void *do_read_exact_wrapper_exec(void *p);
void *do_cursor_read_wrapper_exec(void *p);
void *do_no_overwrite_wrapper_exec(void *p);
void *do_exists_wrapper_exec(void *p);
void *do_overwrite_var_wrapper_exec(void *p);
void *do_read_exact_var_wrapper_exec(void *p);
void *do_delete_var_wrapper_exec(void *p);

void *print_progres(void *p);

int main(int argc, char *argv[])
{
  int r,i,threads;
  char *errmsg;
  pthread_t tid[MAX_THREADS],progres;
  void	*v;
  struct testarg *arg;
  int overwrite=0,read_exact=0,cursor_read=0,no_overwrite=0,exists=0;
  int var_overwrite=0,var_read_exact=0,var_delete=0;
  int max_dlen=-1;
  int num_sdata=-1;
  int num_vdata=-1;
  int do__init=1;
  int sm=0;
  int num=0;
  int ii=2;

  if(argc<2)
    {
      fprintf(stderr,"\nusage: %s test_lenght [-t table] [-db data_source] [-noinit]\n\t[-maxl var_max_len] [-nums num_stat] [-numv num_var]\n\t[-sm sendmail_testapp]\n\t[-o overwrite] [-re read_exact] [-cr cursor_read]\n\t[-no no_overwrite] [-e exists]\n\t[-vo var_overwrite] [-vre var_read_exact] [-vd var_delete]\n",argv[0]);
      exit(1);
    }
  strcpy(table_name,TEST_TABLE);
  dbname = (char*)malloc(255);
  if(dbname==NULL)
    {
       fprintf(stderr,"\ncoudn't allocate mem for dbname, exit\n");
       exit(1);
    }
  strcpy(dbname,"intersolv");

  num=atoi(argv[1]);
  while(ii<argc)
    {
      if(!strcmp(argv[ii],"-t") && ii<(argc-1))
        strcpy(table_name,argv[++ii]);
      else if(!strcmp(argv[ii],"-db") && ii<(argc-1))
	strcpy(dbname,argv[++ii]);
      else if(!strcmp(argv[ii],"-maxl") && ii<(argc-1))
	max_dlen=atoi(argv[++ii]);
      else if(!strcmp(argv[ii],"-nums") && ii<(argc-1))
	num_sdata=atoi(argv[++ii]);
      else if(!strcmp(argv[ii],"-numv") && ii<(argc-1))
	num_vdata=atoi(argv[++ii]);
      else if(!strcmp(argv[ii],"-noinit") && ii<(argc-1))
        {
          do__init=0;
	  ii++;
	}
      else if(!strcmp(argv[ii],"-o") && ii<(argc-1))
	overwrite=atoi(argv[++ii]);
      else if(!strcmp(argv[ii],"-re") && ii<(argc-1))
	read_exact=atoi(argv[++ii]);
      else if(!strcmp(argv[ii],"-cr") && ii<(argc-1))
	cursor_read=atoi(argv[++ii]);
      else if(!strcmp(argv[ii],"-no") && ii<(argc-1))
	no_overwrite=atoi(argv[++ii]);
      else if(!strcmp(argv[ii],"-e") && ii<(argc-1))
	exists=atoi(argv[++ii]);
      else if(!strcmp(argv[ii],"-vo") && ii<(argc-1))
	var_overwrite=atoi(argv[++ii]);
      else if(!strcmp(argv[ii],"-vre") && ii<(argc-1))
	var_read_exact=atoi(argv[++ii]);
      else if(!strcmp(argv[ii],"-vd") && ii<(argc-1))
	var_delete=atoi(argv[++ii]);
       else if(!strcmp(argv[ii],"-sm") && ii<(argc-1))
	sm=atoi(argv[++ii]);
      else
	ii++;
    }

  
  if ((r = msdb_instantiate("Ignored, I think", &db, 1, &errmsg)) != SUCC) 
    {
      fprintf(stderr, "msdb_new failed: %d\n", r);
      exit(1);
    }
  fprintf(stderr,"using table<%s> to run tests\n",table_name);
  pthread_create(&progres, NULL,print_progres,NULL);

  if(do__init)
    do_init(table_name,0,db,max_dlen,num_sdata,num_vdata);

  ii=0;
  for(i=0;i<overwrite && ii<MAX_THREADS;i++,ii++)
    pthread_create(&tid[ii], NULL, do_overwrite_wrapper, (void *) &num);

  for(i=0;i<read_exact && ii<MAX_THREADS;i++,ii++)
    pthread_create(&tid[ii], NULL, do_read_exact_wrapper, (void *) &num);

  for(i=0;i<cursor_read && ii<MAX_THREADS;i++,ii++)
    pthread_create(&tid[ii], NULL, do_cursor_read_wrapper, (void *) &num);
     
  for(i=0;i<no_overwrite && ii<MAX_THREADS;i++,ii++)
    pthread_create(&tid[ii], NULL, do_no_overwrite_wrapper, (void *) &num);
      
  for(i=0;i<exists && ii<MAX_THREADS;i++,ii++)
    pthread_create(&tid[ii], NULL, do_exists_wrapper, (void *) &num);
      
  for(i=0;i<var_overwrite && ii<MAX_THREADS;i++,ii++)
    pthread_create(&tid[ii], NULL, do_overwrite_var_wrapper, (void *) &num);
  
  for(i=0;i<var_read_exact && ii<MAX_THREADS;i++,ii++)
    pthread_create(&tid[ii], NULL, do_read_exact_var_wrapper, (void *) &num);

  for(i=0;i<var_delete && ii<MAX_THREADS;i++,ii++)
    pthread_create(&tid[ii], NULL, do_delete_var_wrapper, (void *) &num);

  for(i=0;i<sm && ii<MAX_THREADS;i++,ii++)
    pthread_create(&tid[ii], NULL, do_test_wrapper, (void *) &num);

  if(ii>=MAX_THREADS)
    fprintf(stderr,"\n *** We can not run more than %d threads(MAX_THREADS) ***\n",
	    MAX_THREADS);
  fprintf(stderr,"We are running with total %d threads in paralell\n",ii);
  for (i = 0; i < ii; i++) {
    pthread_join(tid[i], &v);
  }
  pthread_cancel(progres);

  fprintf(stderr, "Calling msdb_destroy()\n");
  msdb_destroy(&db);
  fprintf(stderr, "The test is OVER!\n\n***** NO CORE DUMP HERE *****\n\n\n**** END ****\n");
  exit(0);
}

void *do_test_wrapper(void *p)
{
  int num= *(int*)p;
  int ii;
  int tid=pthread_self();
  fprintf(stderr, "starting do_test_wrapper(%d)\n", tid);
  for(ii=0;ii<num;ii++)
    {
      do_test("ttest", tid, db);
      fprintf(stderr, "finished do_test_wrapper(%d) num=%d\n",tid,ii);
    }
}

void *print_progres(void *p)
{
  int min=0;
  while(1)
    {
      pthread_testcancel();
      sleep(PROGRESS_MIN*60);
      min+=PROGRESS_MIN;
      fprintf(stderr,"*****  We have been running for: %d min  *****\n",min);
    }
}

void *do_overwrite_wrapper(void *p)
{
  int num= *(int*)p;
  pthread_t tid;
  struct testarg arg;
  void	*v;
  int ii;
  arg.id=(int)pthread_self();
  for(ii=0;ii<num;ii++)
    {
      arg.transactions=myrand(1,MAX_TRANSACTIONS);
      arg.rollbacks=myrand(0,100);
      fprintf(stderr,"do_overwrite(%d) started\n",arg.id);
      pthread_create(&tid, NULL, do_overwrite_wrapper_exec, (void *) &arg);
      pthread_join(tid,&v);
      fprintf(stderr,"do_overwrite(%d) finished %d transactions with %d%% rollback rate\n",
	      arg.id,arg.transactions,arg.rollbacks);
    }
  pthread_exit(NULL);
}

void *do_read_exact_wrapper(void *p)
{
  int num= *(int*)p;
  pthread_t tid;
  struct testarg arg;
  void	*v;
  int ii;
  arg.id=(int)pthread_self();
  for(ii=0;ii<num;ii++)
    {
      arg.transactions=myrand(1,MAX_TRANSACTIONS);
      fprintf(stderr,"do_read_exact(%d) started\n",arg.id);
      pthread_create(&tid, NULL, do_read_exact_wrapper_exec, (void *) &arg);
      pthread_join(tid,&v);
      fprintf(stderr,"do_read_exact(%d) finished %d transactions\n",
	      arg.id,arg.transactions);
    }
  pthread_exit(NULL);
}

void *do_cursor_read_wrapper(void *p)
{
  int num= *(int*)p;
  pthread_t tid;
  struct testarg arg;
  void	*v;
  int ii;
  arg.id=(int)pthread_self();
  for(ii=0;ii<num;ii++)
    {
      arg.transactions=myrand(1,MAX_TRANSACTIONS);
      fprintf(stderr,"do_cursor_read(%d) started\n",arg.id);
      pthread_create(&tid, NULL, do_cursor_read_wrapper_exec, (void *) &arg);
      pthread_join(tid,&v);
      fprintf(stderr,"do_cursor_read(%d) finished %d transactions\n",
	      arg.id,arg.transactions);
    }
  pthread_exit(NULL);
}

void *do_no_overwrite_wrapper(void *p)
{
  int num= *(int*)p;
  pthread_t tid;
  struct testarg arg;
  void	*v;
  int ii;
  arg.id=(int)pthread_self();
  for(ii=0;ii<num;ii++)
    {
      arg.transactions=myrand(1,MAX_TRANSACTIONS);
      fprintf(stderr,"do_no_overwrite(%d) started\n",arg.id);
      pthread_create(&tid, NULL, do_no_overwrite_wrapper_exec, (void *) &arg);
      pthread_join(tid,&v);
      fprintf(stderr,"do_no_overwrite(%d) finished %d transactions\n",
	      arg.id,arg.transactions);
    }
  pthread_exit(NULL);
}

void *do_exists_wrapper(void *p)
{
  int num= *(int*)p;
  pthread_t tid;
  struct testarg arg;
  void	*v;
  int ii;
  arg.id=(int)pthread_self();
  for(ii=0;ii<num;ii++)
    {
      arg.transactions=myrand(1,MAX_TRANSACTIONS);
      fprintf(stderr,"do_exists(%d) started\n",arg.id);
      pthread_create(&tid, NULL, do_exists_wrapper_exec, (void *) &arg);
      pthread_join(tid,&v);
      fprintf(stderr,"do_exists(%d) finished %d transactions\n",
	      arg.id,arg.transactions);
    }
  pthread_exit(NULL);
}

void *do_overwrite_var_wrapper(void *p)
{
  int num= *(int*)p;
  pthread_t tid;
  struct testarg arg;
  void	*v;
  int ii;
  arg.id=(int)pthread_self();
  for(ii=0;ii<num;ii++)
    {
      arg.transactions=myrand(1,MAX_TRANSACTIONS);
      arg.rollbacks=myrand(1,100);
      fprintf(stderr,"do_overwrite_var(%d) started\n",arg.id);
      pthread_create(&tid, NULL, do_overwrite_var_wrapper_exec, (void *) &arg);
      pthread_join(tid,&v);
      fprintf(stderr,"do_overwrite_var(%d) finished %d transactions with %d%% rollback rate\n",
	      arg.id,arg.transactions,arg.rollbacks);
    }
  pthread_exit(NULL);
}

void *do_read_exact_var_wrapper(void *p)
{
  int num= *(int*)p;
  pthread_t tid;
  struct testarg arg;
  void	*v;
  int ii;
  arg.id=(int)pthread_self();
  for(ii=0;ii<num;ii++)
    {
      arg.transactions=myrand(1,MAX_TRANSACTIONS);
      fprintf(stderr,"do_read_exact_var(%d) started\n",arg.id);
      pthread_create(&tid, NULL, do_read_exact_var_wrapper_exec, (void *) &arg);
      pthread_join(tid,&v);
    }
  pthread_exit(NULL);
}

void *do_delete_var_wrapper(void *p)
{
  int num= *(int*)p;
  pthread_t tid;
  struct testarg arg;
  void	*v;
  int ii;
  arg.id=(int)pthread_self();
  for(ii=0;ii<num;ii++)
    {
      arg.transactions=myrand(1,MAX_TRANSACTIONS);
      fprintf(stderr,"do_delete_var(%d) started\n",arg.id);
      pthread_create(&tid, NULL, do_delete_var_wrapper_exec, (void *) &arg);
      pthread_join(tid,&v);
    }
  pthread_exit(NULL);
}

void *do_overwrite_wrapper_exec(void *p)
{
  struct testarg *arg=(struct testarg*)p;
  do_overwrites(table_name,arg->id,db,arg->transactions,arg->rollbacks);
  pthread_exit(NULL);
}

void *do_read_exact_wrapper_exec(void *p)
{
  struct testarg *arg=(struct testarg*)p;
  do_read_exact(table_name,arg->id,db,arg->transactions);
  pthread_exit(NULL);
  pthread_exit(NULL);
}

void *do_cursor_read_wrapper_exec(void *p)
{
  struct testarg *arg=(struct testarg*)p;
  do_cursor_read(table_name,arg->id,db,arg->transactions);
  pthread_exit(NULL);
}

void *do_no_overwrite_wrapper_exec(void *p)
{
  struct testarg *arg=(struct testarg*)p;
  do_no_overwrites(table_name,arg->id,db,arg->transactions);
  pthread_exit(NULL);
}

void *do_exists_wrapper_exec(void *p)
{
  struct testarg *arg=(struct testarg*)p;
  do_exists(table_name,arg->id,db,arg->transactions);
  pthread_exit(NULL);
}

void *do_overwrite_var_wrapper_exec(void *p)
{
  struct testarg *arg=(struct testarg*)p;
  do_overwrites_var(table_name,arg->id,db,arg->transactions,arg->rollbacks);
  pthread_exit(NULL);
}

void *do_read_exact_var_wrapper_exec(void *p)
{
  int failed;
  struct testarg *arg=(struct testarg*)p;
  failed=do_read_exact_var(table_name,arg->id,db,arg->transactions);
  fprintf(stderr,"do_read_exact_var(%d) finished %d failures out of %d\n",
	  arg->id,failed,arg->transactions);
  pthread_exit(NULL);
}

void *do_delete_var_wrapper_exec(void *p)
{
  int failed;
  struct testarg *arg=(struct testarg*)p;
  failed=do_delete_var(table_name,arg->id,db,arg->transactions);
  fprintf(stderr,"do_delete_var(%d) finished with %d transactions\n",
	  arg->id,arg->transactions);
  pthread_exit(NULL);
}
